<?php

declare(strict_types=1);

use Phinx\Migration\AbstractMigration;

final class CreateReservationDatas extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * https://book.cakephp.org/phinx/0/en/migrations.html#the-change-method
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change(): void
    {
        $this->execute('SET unique_checks=0; SET foreign_key_checks=0;');
        $this->execute("ALTER DATABASE CHARACTER SET 'utf8mb4';");
        $this->execute("ALTER DATABASE COLLATE='utf8mb4_general_ci';");

        $this->table('reservation_data')
            ->addColumn('reservation_id', 'integer', ['signed' => false, 'null' => false])
            ->addColumn('type', 'integer', ['length' => 1, 'signed' => false, 'null' => false])
            ->addColumn('reference_id', 'integer', ['signed' => false, 'null' => false])
            ->addColumn('value', 'decimal', ['precision' => 10, 'scale' => 2, 'signed' => false, 'default' => 0.00, 'null' => true])
            ->create();

        $this->execute('SET unique_checks=1; SET foreign_key_checks=1;');
    }
}
